Quota modules are missing from the package

Bug #761809 reported by BK Box on 2011-04-15
36
This bug affects 6 people
Affects Status Importance Assigned to Milestone
linux (Ubuntu)
Medium
Unassigned
Maverick
Medium
Stefan Bader
Natty
Medium
Stefan Bader

Bug Description

SRU Justification:

Impact: The quota filesystem modules are currently not included in the virtual kernel package. However those are important if a virtual system is used to offer user facing services that require to enforce disk space limitations.

Fix: Add the quota modules to the virtual package.

Testcase: Running "modinfo quota_v1" or "modinfo quota_v2" on a system running the virtual kernel.

---

Binary package hint: linux-virtual

In linux-virtual, the /boot/config file states that the quota format modules have been compiled as such, but the files are not provided by the package:

# grep QFMT /boot/config-2.6.35-24-virtual
CONFIG_QFMT_V1=m
CONFIG_QFMT_V2=m
# ls -l /lib64/modules/2.6.35-24-virtual/kernel/fs/quota/
total 0

This causes quotas to not work at all since the kernel can't read the /quota.[user|group] files.

ProblemType: Bug
DistroRelease: Ubuntu 10.10
Package: linux-virtual 2.6.35.28.36
Regression: No
Reproducible: Yes
ProcVersionSignature: Ubuntu 2.6.35-24.42-virtual 2.6.35.8
Uname: Linux 2.6.35-24-virtual x86_64
AlsaDevices: Error: command ['ls', '-l', '/dev/snd/'] failed with exit code 2: ls: cannot access /dev/snd/: No such file or directory
AplayDevices: Error: [Errno 2] No such file or directory
Architecture: amd64
ArecordDevices: Error: [Errno 2] No such file or directory
Date: Fri Apr 15 09:00:14 2011
Lspci: Error: [Errno 2] No such file or directory
Lsusb: Error: [Errno 2] No such file or directory
PciMultimedia:

ProcCmdLine: ro console=hvc0 root=/dev/sda1
ProcEnviron:
 LANG=en_US.utf8
 SHELL=/bin/bash
SourcePackage: linux
---
AcpiTables:

AlsaDevices:
 total 0
 crw------- 1 root root 116, 1 2011-09-19 17:11 seq
 crw------- 1 root root 116, 33 2011-09-19 17:11 timer
AplayDevices: Error: [Errno 2] No such file or directory
Architecture: amd64
ArecordDevices: Error: [Errno 2] No such file or directory
AudioDevicesInUse: Error: command ['fuser', '-v', '/dev/snd/seq', '/dev/snd/timer'] failed with exit code 1:
CRDA: Error: [Errno 2] No such file or directory
DistroRelease: Ubuntu 11.04
IwConfig: Error: [Errno 2] No such file or directory
Lspci: Error: [Errno 2] No such file or directory
Lsusb: Error: [Errno 2] No such file or directory
Package: linux (not installed)
PciMultimedia:

ProcEnviron:
 LANG=en_US.UTF-8
 SHELL=/bin/bash
ProcKernelCmdLine: ro console=hvc0 root=/dev/xvda1
ProcVersionSignature: Ubuntu 2.6.38-8.42-virtual 2.6.38.2
RelatedPackageVersions:
 linux-restricted-modules-2.6.38-8-virtual N/A
 linux-backports-modules-2.6.38-8-virtual N/A
 linux-firmware 1.52
RfKill: Error: [Errno 2] No such file or directory
Tags: natty
Uname: Linux 2.6.38-8-virtual x86_64
UpgradeStatus: No upgrade log present (probably fresh install)
UserGroups:

BK Box (bkbox) wrote :
BK Box (bkbox) wrote :
BK Box (bkbox) wrote :
BK Box (bkbox) wrote :
BK Box (bkbox) wrote :
Brad Figg (brad-figg) on 2011-06-30
affects: linux-meta (Ubuntu) → linux (Ubuntu)

This bug is missing log files that will aid in dianosing the problem. From a terminal window please run:

apport-collect 761809

and then change the status of the bug back to 'New'.

If, due to the nature of the issue you have encountered, you are unable to run this command, please add a comment stating that fact and change the bug status to 'Confirmed'.

This change has been made by an automated script, maintained by the Ubuntu Kernel Team.

Changed in linux (Ubuntu):
status: New → Incomplete
Launchpad Janitor (janitor) wrote :

[Expired for linux (Ubuntu) because there has been no activity for 60 days.]

Changed in linux (Ubuntu):
status: Incomplete → Expired
BK Box (bkbox) wrote : BootDmesg.txt

apport information

tags: added: apport-collected natty
description: updated

apport information

apport information

apport information

apport information

apport information

BK Box (bkbox) wrote : UdevDb.txt

apport information

BK Box (bkbox) wrote : UdevLog.txt

apport information

apport information

BK Box (bkbox) wrote :

This is still the case in oneiric:

$ wget http://us.archive.ubuntu.com/ubuntu/pool/main/l/linux/linux-image-3.0.0-11-virtual_3.0.0-11.18_amd64.deb
$ dpkg -x linux-image-3.0.0-11-virtual_3.0.0-11.18_amd64.deb .
$ ls -l lib/modules/3.0.0-11-virtual/kernel/fs/quota/
total 0

Changed in linux (Ubuntu):
status: Expired → Confirmed
Scott Moser (smoser) wrote :

As discussed in the ubuntu server team meeting
http://irclogs.ubuntu.com/2011/09/20/%23ubuntu-meeting.html#t16:02

There will be a -extras package that will contain the additoinal modules that were built.

BK Box (bkbox) wrote :

If there is going to be a new package to handle this going forward, what is going to be the SRU process for older releases, specifically LTS?

Stefan Bader (smb) wrote :

As a first step it would help to have a bit more help in reasoning why those modules are needed. The virtual package was targeted to be used as a guest kernel in a vm. To keep the package footprint small some modules were not packaged. Now to get them added to the older releases it helps to have a real-world use case to make the argument.

Lucid (10.04) is even more a special case. Back then, the virtual packages are just module subsets of the generic-pae (i386) or server (amd64) packages. While later virtual became its own flavour which allowed us to use slightly tuned compile options.
So, as confusing as all of this is, in Lucid one can use generic-pae or server and get all modules, while later on there is a difference (though mainly whether xen drivers are built-in or modules).

BK Box (bkbox) wrote :

Without the quota modules, a server cannot have data quotas per user on the filesystem. This effects all versions up to Oneiric. When a person uses any kind of quota restriction whether it's manual, or via an application such as Plesk or CPanel, it will not work since these modules are missing.

Yes, this can be worked around by downloading a different kernel and loading up the modules from that kernel, but it is just that, a workaround. The environment we are using Ubuntu in, has automated deployments that needs/uses the -virtual kernel. It would cause more overhead to use this workaround every time we deploy a new Ubuntu box.

This is a standard module that is needed no matter what kernel or server is in use, and should be considered as a bug that needs to be fixed.

Stefan Bader (smb) wrote :

For Lucid (10.04) this is actually already fixed for the kernel in updates at least:

dpkg --contents linux-image-2.6.32-33-virtual_2.6.32-33.72_i386.deb |grep quot
-rw-r--r-- root/root 4476 2011-07-30 02:37 ./lib/modules/2.6.32-33-generic-pae/kernel/net/netfilter/xt_quota.ko
drwxr-xr-x root/root 0 2011-07-30 02:37 ./lib/modules/2.6.32-33-generic-pae/kernel/fs/quota/
-rw-r--r-- root/root 11776 2011-07-30 02:37 ./lib/modules/2.6.32-33-generic-pae/kernel/fs/quota/quota_tree.ko
-rw-r--r-- root/root 5568 2011-07-30 02:37 ./lib/modules/2.6.32-33-generic-pae/kernel/fs/quota/quota_v1.ko
-rw-r--r-- root/root 6952 2011-07-30 02:37 ./lib/modules/2.6.32-33-generic-pae/kernel/fs/quota/quota_v2.ko

Maverick (10.10) is not really worth fixing. But I'll queue up changes for Natty (11.04). As mentioned for Oneiric we will have an extra package with anything not added to the kernel package directly, so that should be resolved.

Changed in linux (Ubuntu Natty):
assignee: nobody → Stefan Bader (stefan-bader-canonical)
importance: Undecided → Medium
status: New → In Progress
Changed in linux (Ubuntu):
importance: Undecided → Medium
status: Confirmed → Fix Committed
Stefan Bader (smb) on 2011-09-22
description: updated
Tim Gardner (timg-tpi) on 2011-09-22
Changed in linux (Ubuntu Natty):
status: In Progress → Fix Committed

"Maverick (10.10) is not really worth fixing"

Why is that? There's still seven months to go.

I have this -exact- (quota) problem with a 10.10 Amazon EC2 instance (2.6.35-24-virtual i386/i686, I don't have the ami & aki to hand)

It seems it wouldn't be that difficult to roll quota* into the next kernel -virtual update for 10.10?

At present, I can't see what the valid workaround is. Apparently:

* -server doesn't have the right Xen bits for Amazon EC2
* -ec2 is the "old" Amazon EC2 kernel and we should be using -virtual from now on

This leaves me with -: roll our own (obviously more work and not future proofed) or do a complete in place upgrade to 11.04?

I would appreciate views on what the valid workaround is.

I can see how you might want to drop hardware specific drivers or obscure functionality but there seems to have been some pretty rampant pruning done for -virtual all around. It doesn't take much Googl'ing to find at least a couple of bug reports showing the dropping of nfs related stuff, modules relating to character sets that I would have thought were 'core' OS.

Stefan Bader (smb) wrote :

Mostly because of trying to minimize changes that are not critical for older releases that are not LTS or the current one. Ok and probably the assumption that with virtual deployments those things would move quicker to the current release. But no, the change is not really hard to make and if there is a real need and someone to do testing feedback, it could be done.

Stefan Bader (smb) on 2011-09-23
Changed in linux (Ubuntu Maverick):
assignee: nobody → Stefan Bader (stefan-bader-canonical)
importance: Undecided → Medium
status: New → In Progress
Tim Gardner (timg-tpi) on 2011-09-23
Changed in linux (Ubuntu Maverick):
status: In Progress → Fix Committed

Thanks. When will this be available for testing, and/or fully released? Wondering if there is anything further I need to do.

Stefan Bader (smb) wrote :

Stay tuned here. There will be an announcement when a new kernel package that contains this change is uploaded into proposed for testing. Make sure to verify/comment whether that package has the modules missing. It should be in the next one but I cannot give an exact timeline.

Herton R. Krzesinski (herton) wrote :

This bug is awaiting verification that the kernel for Natty in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-natty' to 'verification-done-natty'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-natty
Stefan Bader (smb) wrote :

dpkg --contents linux-image-2.6.38-12-virtual_2.6.38-12.51_i386.deb|grep quota
drwxr-xr-x root/root 0 2011-09-28 23:02 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/
-rw-r--r-- root/root 12928 2011-09-28 23:02 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_tree.ko
-rw-r--r-- root/root 6036 2011-09-28 23:02 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_v1.ko
-rw-r--r-- root/root 8324 2011-09-28 23:02 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_v2.ko
-rw-r--r-- root/root 4164 2011-09-28 23:02 ./lib/modules/2.6.38-12-virtual/kernel/net/netfilter/xt_quota.ko

dpkg --contents linux-image-2.6.38-12-virtual_2.6.38-12.51_amd64.deb|grep quota
drwxr-xr-x root/root 0 2011-09-28 23:33 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/
-rw-r--r-- root/root 17720 2011-09-28 23:33 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_tree.ko
-rw-r--r-- root/root 7816 2011-09-28 23:33 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_v1.ko
-rw-r--r-- root/root 11432 2011-09-28 23:33 ./lib/modules/2.6.38-12-virtual/kernel/fs/quota/quota_v2.ko
-rw-r--r-- root/root 5744 2011-09-28 23:33 ./lib/modules/2.6.38-12-virtual/kernel/net/netfilter/xt_quota.ko

tags: added: verification-done-natty
removed: verification-needed-natty
dcannell (k-dcannell) wrote :

I am ready and willing to test this for 10.10, Maverik when available. Any word?

Herton R. Krzesinski (herton) wrote :

This bug is awaiting verification that the kernel for Maverick in -proposed solves the problem. Please test the kernel and update this bug with the results. If the problem is solved, change the tag 'verification-needed-maverick' to 'verification-done-maverick'.

If verification is not done by one week from today, this fix will be dropped from the source code, and this bug will be closed.

See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Thank you!

tags: added: verification-needed-maverick
dcannell (k-dcannell) wrote :

Looks good to me

# dpkg --contents linux-image-2.6.35-30-virtual_2.6.35-30.61_i386.deb | grep quota
drwxr-xr-x root/root 0 2011-10-11 19:32 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/
-rw-r--r-- root/root 13472 2011-10-11 19:32 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_tree.ko
-rw-r--r-- root/root 5844 2011-10-11 19:32 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_v1.ko
-rw-r--r-- root/root 8596 2011-10-11 19:32 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_v2.ko
-rw-r--r-- root/root 4520 2011-10-11 19:32 ./lib/modules/2.6.35-30-virtual/kernel/net/netfilter/xt_quota.ko

# dpkg --contents linux-image-2.6.35-30-virtual_2.6.35-30.61_amd64.deb | grep quota
drwxr-xr-x root/root 0 2011-10-12 08:16 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/
-rw-r--r-- root/root 7568 2011-10-12 08:16 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_v1.ko
-rw-r--r-- root/root 18800 2011-10-12 08:16 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_tree.ko
-rw-r--r-- root/root 11728 2011-10-12 08:16 ./lib/modules/2.6.35-30-virtual/kernel/fs/quota/quota_v2.ko
-rw-r--r-- root/root 6208 2011-10-12 08:16 ./lib/modules/2.6.35-30-virtual/kernel/net/netfilter/xt_quota.ko

BEFORE (Fresh Install)
==================

# uname -a
Linux ip-10-131-42-212 2.6.35-24-virtual #42-Ubuntu SMP Thu Dec 2 05:01:52 UTC 2010 i686 GNU/Linux
# mount |grep quota
/dev/loop0 on /mnt/quota type ext4 (rw,usrquota,grpquota)
#
# ls -l /lib/modules/2.6.35-24-virtual/kernel/fs/quota/
total 0
# quotaon /mnt/quota/
quotaon: using /mnt/quota/aquota.group on /dev/loop0 [/mnt/quota]: No such process
quotaon: Quota format not supported in kernel.
quotaon: using /mnt/quota/aquota.user on /dev/loop0 [/mnt/quota]: No such process
quotaon: Quota format not supported in kernel.
root@ip-10-131-42-212:/var/tmp# lsmod |grep quota
#

AFTER
======

# uname -a
Linux ip-10-131-42-212 2.6.35-30-virtual #61-Ubuntu SMP Tue Oct 11 17:34:26 UTC 2011 i686 GNU/Linux
# mount | grep quota
/dev/loop0 on /mnt/quota type ext4 (rw,usrquota,grpquota)
# lsmod |grep quota
# ls -l /lib/modules/2.6.35-30-virtual/kernel/fs/quota/
total 36
-rw-r--r-- 1 root root 13472 2011-10-11 19:32 quota_tree.ko
-rw-r--r-- 1 root root 5844 2011-10-11 19:32 quota_v1.ko
-rw-r--r-- 1 root root 8596 2011-10-11 19:32 quota_v2.ko
# quotaon /mnt/quota/
# echo $?
0
# lsmod |grep quota
quota_v2 3982 2
quota_tree 8334 1 quota_v2

tags: added: verification-done-maverick
removed: verification-needed-maverick
tags: removed: verification-done-maverick
tags: added: verification-done-maverick
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.38-12.51

---------------
linux (2.6.38-12.51) natty-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #860832

  [ Alex Bligh ]

  * SAUCE: net/netfilter/nf_conntrack_netlink.c: fix Oops on container
    destroy
    - LP: #843892

  [ Jesse Sung ]

  * SAUCE: Unregister input device only if it is registered
    - LP: #839238

  [ Leann Ogasawara ]

  * SAUCE: x86: reboot: Make Dell Latitude E6220 use reboot=pci
    - LP: #838402
  * SAUCE: x86: reboot: Make Dell Latitude E6520 use reboot=pci
    - LP: #833705

  [ Ming Lei ]

  * SAUCE: fireware: add NO_MSI quirks for o2micro controller
    - LP: #801719

  [ Stefan Bader ]

  * [Config] Include all filesystem modules for virtual
    - LP: #761809

  [ Tim Gardner ]

  * [Config] kernel preparation cannot be parallelized
  * [Config] Linearize module/abi checks
  * [Config] Linearize and simplify tree preparation rules
  * [Config] Build kernel image in parallel with modules
  * [Config] Set concurrency for kmake invocations
  * [Config] Improve install-arch-headers speed
  * [Config] Fix binary-perarch dependencies
  * [Config] Removed stamp-flavours target
  * [Config] Serialize binary indep targets
  * [Config] Use build stamp directly
  * [Config] Restore prepare-% target
  * [Config] Fix binary-% build target

  [ Upstream Kernel Changes ]

  * Revert "drm/i915: disable PCH ports if needed when disabling a CRTC"
    - LP: #814325, #838181
  * drm/i915: restore only the mode of this driver on lastclose (v2)
    - LP: #848687
  * cifs: fix possible memory corruption in CIFSFindNext, CVE-2011-3191
    - LP: #834135
    - CVE-2011-3191
  * befs: Validate length of long symbolic links, CVE-2011-2928
    - LP: #834124
    - CVE-2011-2928
  * gro: Only reset frag0 when skb can be pulled, CVE-2011-2723
    - LP: #844371
    - CVE-2011-2723
  * inet_diag: fix inet_diag_bc_audit(), CVE-2011-2213
    - LP: #838421
    - CVE-2011-2213
  * si4713-i2c: avoid potential buffer overflow on si4713, CVE-2011-2700
    - LP: #844370
    - CVE-2011-2700
  * Bluetooth: Prevent buffer overflow in l2cap config request,
    CVE-2011-2497
    - LP: #838423
    - CVE-2011-2497
  * crypto: Move md5_transform to lib/md5.c, CVE-2011-3188
    - LP: #834129
    - CVE-2011-3188
  * net: Compute protocol sequence numbers and fragment IDs using MD5,
    CVE-2011-3188
    - LP: #834129
    - CVE-2011-3188
  * x86, intel, power: Initialize MSR_IA32_ENERGY_PERF_BIAS
    - LP: #760131
  * x86, intel, power: Correct the MSR_IA32_ENERGY_PERF_BIAS message
    - LP: #760131
  * rt2x00: Serialize TX operations on a queue.
    - LP: #855239
  * ext4: Fix max file size and logical block counting of extent format
    file, CVE-2011-2695
    - LP: #819574
    - CVE-2011-2695
 -- Herton Ronaldo Krzesinski <email address hidden> Tue, 27 Sep 2011 16:19:57 -0300

Changed in linux (Ubuntu Natty):
status: Fix Committed → Fix Released
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package linux - 2.6.35-30.61

---------------
linux (2.6.35-30.61) maverick-proposed; urgency=low

  [Herton R. Krzesinski]

  * Release Tracking Bug
    - LP: #871912

  [ Stefan Bader ]

  * [Config] Include all filesystem modules for virtual
    - LP: #761809

  [ Upstream Kernel Changes ]

  * crypto: Move md5_transform to lib/md5.c, CVE-2011-3188
    - LP: #834129
    - CVE-2011-3188
  * net: Compute protocol sequence numbers and fragment IDs using MD5,
    CVE-2011-3188
    - LP: #834129
    - CVE-2011-3188
  * ext4: Fix max file size and logical block counting of extent format
    file, CVE-2011-2695
    - LP: #819574
    - CVE-2011-2695
  * cifs: add fallback in is_path_accessible for old servers, CVE-2011-3363
    - LP: #866034
    - CVE-2011-3363
  * Make TASKSTATS require root access, CVE-2011-2494
    - LP: #866021
    - CVE-2011-2494
  * proc: restrict access to /proc/PID/io, CVE-2011-2495
    - LP: #866025
    - CVE-2011-2495
  * proc: fix a race in do_io_accounting(), CVE-2011-2495
    - LP: #866025
    - CVE-2011-2495
  * inotify: fix double free/corruption of stuct user
    - LP: #869203
    - CVE-2011-1479
  * staging: comedi: fix infoleak to userspace, CVE-2011-2909
    - LP: #869261
    - CVE-2011-2909
  * perf tools: do not look at ./config for configuration, CVE-2011-2905
    - LP: #869259
    - CVE-2011-2905
 -- Herton Ronaldo Krzesinski <email address hidden> Mon, 10 Oct 2011 14:37:08 -0300

Changed in linux (Ubuntu Maverick):
status: Fix Committed → Fix Released
Julian Wiedmann (jwiedmann) wrote :

On Oneiric and Precise, these modules are in the linux-image-extra-virtual package.

Changed in linux (Ubuntu):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers